_checksumCheck:
;CRC_check.c,30 :: 		short checksumCheck( unsigned char * ptrIntern ){
ADDIU	SP, SP, -60
SW	RA, 0(SP)
;CRC_check.c,32 :: 		unsigned short result = 0;
MOVZ	R30, R0, R0
SB	R30, 49(SP)
MOVZ	R30, R0, R0
SB	R30, 50(SP)
MOVZ	R30, R0, R0
SB	R30, 51(SP)
;CRC_check.c,33 :: 		unsigned short checkSumCalculated = 0;
;CRC_check.c,34 :: 		unsigned short checkSumIdentified = 0;
;CRC_check.c,35 :: 		unsigned short recordLength = 0;
;CRC_check.c,36 :: 		unsigned short adress1 = 0;
;CRC_check.c,37 :: 		unsigned short adress2 = 0;
;CRC_check.c,38 :: 		unsigned short recordType = 0;
;CRC_check.c,39 :: 		unsigned short i = 0;
;CRC_check.c,40 :: 		unsigned int   digitSum = 0;
MOVZ	R30, R0, R0
SH	R30, 52(SP)
;CRC_check.c,42 :: 		if( *ptrIntern != ':'){
LW	R2, 60(SP)
LBU	R2, 0(R2)
ANDI	R3, R2, 255
ORI	R2, R0, 58
BNE	R3, R2, L__checksumCheck12
NOP	
J	L_checksumCheck0
NOP	
L__checksumCheck12:
;CRC_check.c,43 :: 		return -1;
ORI	R2, R0, 255
J	L_end_checksumCheck
NOP	
;CRC_check.c,44 :: 		}
L_checksumCheck0:
;CRC_check.c,45 :: 		ptrIntern++;
LW	R2, 60(SP)
ADDIU	R2, R2, 1
SW	R2, 60(SP)
;CRC_check.c,46 :: 		for(i = 0; i < 45; i++){ // copy hex line into internal buffer, convert it to numbers and copy it to internal array
SB	R0, 51(SP)
L_checksumCheck1:
LBU	R2, 51(SP)
SLTIU	R2, R2, 45
BNE	R2, R0, L__checksumCheck13
NOP	
J	L_checksumCheck2
NOP	
L__checksumCheck13:
;CRC_check.c,47 :: 		result = *ptrIntern;
LW	R2, 60(SP)
LBU	R2, 0(R2)
SB	R2, 49(SP)
;CRC_check.c,48 :: 		hexRawLineIntern[i] = xtoi( &result );
ADDIU	R3, SP, 4
LBU	R2, 51(SP)
ADDU	R2, R3, R2
SW	R2, 56(SP)
ADDIU	R2, SP, 49
MOVZ	R25, R2, R0
JAL	_xtoi+0
NOP	
LW	R3, 56(SP)
SB	R2, 0(R3)
;CRC_check.c,49 :: 		ptrIntern++;
LW	R2, 60(SP)
ADDIU	R2, R2, 1
SW	R2, 60(SP)
;CRC_check.c,46 :: 		for(i = 0; i < 45; i++){ // copy hex line into internal buffer, convert it to numbers and copy it to internal array
LBU	R2, 51(SP)
ADDIU	R2, R2, 1
SB	R2, 51(SP)
;CRC_check.c,50 :: 		}
J	L_checksumCheck1
NOP	
L_checksumCheck2:
;CRC_check.c,52 :: 		recordLength =  (hexRawLineIntern[0] << 4) | hexRawLineIntern[1];
ADDIU	R4, SP, 4
LBU	R2, 0(R4)
ANDI	R2, R2, 255
SLL	R3, R2, 4
ADDIU	R2, R4, 1
LBU	R2, 0(R2)
OR	R7, R3, R2
SB	R7, 50(SP)
;CRC_check.c,53 :: 		adress1      = ((hexRawLineIntern[2] << 4) | hexRawLineIntern[3]);
ADDIU	R2, R4, 2
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 4
ADDIU	R2, R4, 3
LBU	R2, 0(R2)
OR	R6, R3, R2
;CRC_check.c,54 :: 		adress2      = ((hexRawLineIntern[4] << 4) | hexRawLineIntern[5]);
ADDIU	R2, R4, 4
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 4
ADDIU	R2, R4, 5
LBU	R2, 0(R2)
OR	R5, R3, R2
;CRC_check.c,55 :: 		recordType   = ((hexRawLineIntern[6] << 4) | hexRawLineIntern[7]);
ADDIU	R2, R4, 6
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 4
ADDIU	R2, R4, 7
LBU	R2, 0(R2)
OR	R4, R3, R2
;CRC_check.c,56 :: 		digitSum    = recordLength + adress1 + adress2 + recordType;
ANDI	R3, R6, 255
ANDI	R2, R7, 255
ADDU	R3, R2, R3
ANDI	R2, R5, 255
ADDU	R3, R3, R2
ANDI	R2, R4, 255
ADDU	R2, R3, R2
SH	R2, 52(SP)
;CRC_check.c,64 :: 		for( i = 1; i <= recordLength*2; i+= 2){    // sum up data bytes
ORI	R2, R0, 1
SB	R2, 51(SP)
L_checksumCheck4:
LBU	R2, 50(SP)
SLL	R2, R2, 1
SEH	R3, R2
LBU	R2, 51(SP)
SLT	R2, R3, R2
BEQ	R2, R0, L__checksumCheck14
NOP	
J	L_checksumCheck5
NOP	
L__checksumCheck14:
;CRC_check.c,65 :: 		result = (hexRawLineIntern[i+7] << 4) | hexRawLineIntern[i+8];
LBU	R2, 51(SP)
ADDIU	R2, R2, 7
ADDIU	R4, SP, 4
SEH	R2, R2
ADDU	R2, R4, R2
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 4
LBU	R2, 51(SP)
ADDIU	R2, R2, 8
SEH	R2, R2
ADDU	R2, R4, R2
LBU	R2, 0(R2)
OR	R2, R3, R2
SB	R2, 49(SP)
;CRC_check.c,66 :: 		digitSum += result;
ANDI	R3, R2, 255
LHU	R2, 52(SP)
ADDU	R2, R2, R3
SH	R2, 52(SP)
;CRC_check.c,64 :: 		for( i = 1; i <= recordLength*2; i+= 2){    // sum up data bytes
LBU	R2, 51(SP)
ADDIU	R2, R2, 2
SB	R2, 51(SP)
;CRC_check.c,67 :: 		}
J	L_checksumCheck4
NOP	
L_checksumCheck5:
;CRC_check.c,68 :: 		checkSumIdentified = (hexRawLineIntern[i+7] << 4) | hexRawLineIntern[i+8];    // get Checksum from Array
LBU	R2, 51(SP)
ADDIU	R2, R2, 7
ADDIU	R4, SP, 4
SEH	R2, R2
ADDU	R2, R4, R2
LBU	R2, 0(R2)
ANDI	R2, R2, 255
SLL	R3, R2, 4
LBU	R2, 51(SP)
ADDIU	R2, R2, 8
SEH	R2, R2
ADDU	R2, R4, R2
LBU	R2, 0(R2)
OR	R4, R3, R2
;CRC_check.c,70 :: 		result = (unsigned char) digitSum ; // mask to least significant Byte
LBU	R2, 52(SP)
SB	R2, 49(SP)
;CRC_check.c,71 :: 		result = ~result;                   // two complement   ~ bitwise complement (unary); inverts each bit
LBU	R2, 52(SP)
NOR	R2, R2, R0
SB	R2, 49(SP)
;CRC_check.c,72 :: 		checkSumCalculated = result + 1;    // add 1
ADDIU	R2, R2, 1
;CRC_check.c,74 :: 		if( checkSumCalculated == checkSumIdentified)
ANDI	R3, R2, 255
ANDI	R2, R4, 255
BEQ	R3, R2, L__checksumCheck15
NOP	
J	L_checksumCheck7
NOP	
L__checksumCheck15:
;CRC_check.c,75 :: 		return +1;
ORI	R2, R0, 1
J	L_end_checksumCheck
NOP	
L_checksumCheck7:
;CRC_check.c,77 :: 		return -1;
ORI	R2, R0, 255
;CRC_check.c,78 :: 		}
L_end_checksumCheck:
LW	RA, 0(SP)
ADDIU	SP, SP, 60
JR	RA
NOP	
; end of _checksumCheck
_main:
;CRC_check.c,81 :: 		void main() {
ADDIU	SP, SP, -4
;CRC_check.c,82 :: 		volatile short result1 = 0;
MOVZ	R30, R0, R0
SB	R30, 0(SP)
MOVZ	R30, R0, R0
SB	R30, 1(SP)
MOVZ	R30, R0, R0
SB	R30, 2(SP)
;CRC_check.c,83 :: 		volatile short result2 = 0;
;CRC_check.c,84 :: 		volatile short result3 = 0;
;CRC_check.c,87 :: 		result1 = checksumCheck(buffer1);
LUI	R2, hi_addr(_buffer1+0)
ORI	R2, R2, lo_addr(_buffer1+0)
ADDIU	SP, SP, -4
SW	R2, 0(SP)
JAL	_checksumCheck+0
NOP	
ADDIU	SP, SP, 4
SB	R2, 0(SP)
;CRC_check.c,88 :: 		result2 = checksumCheck(buffer2);
LUI	R2, hi_addr(_buffer2+0)
ORI	R2, R2, lo_addr(_buffer2+0)
ADDIU	SP, SP, -4
SW	R2, 0(SP)
JAL	_checksumCheck+0
NOP	
ADDIU	SP, SP, 4
SB	R2, 1(SP)
;CRC_check.c,89 :: 		result3 = checksumCheck(buffer3);
LUI	R2, hi_addr(_buffer3+0)
ORI	R2, R2, lo_addr(_buffer3+0)
ADDIU	SP, SP, -4
SW	R2, 0(SP)
JAL	_checksumCheck+0
NOP	
ADDIU	SP, SP, 4
SB	R2, 2(SP)
;CRC_check.c,91 :: 		while(1){
L_main8:
;CRC_check.c,93 :: 		}
J	L_main8
NOP	
;CRC_check.c,94 :: 		}
L_end_main:
L__main_end_loop:
J	L__main_end_loop
NOP	
; end of _main
